* SPring8 BL15XU IMG file read and bmp or csv out   2010/1/26
* conversion coefficients are given by sp8img.inf   2010/1/27
* IMG file format
*   no Header part (refer *.inf file)
*   Standard data is consisted of 4000x8000 pixcels
*      Intensity date is 2 bytes
* mercury     Intensity=ichar(byte1)+256*ichar(byte2)
* BL15XU      Intensity=256*ichar(byte1)+ichar(byte2)
*   input(1) *.img and output(2) *.bmp or *.csv file names
*      character*256 da
      character*64 fnm1,fnm2
      integer pv(2000,4000),pvdat1(4000),pvdat2(4000)
      integer x1,x2,y1,y2
      data c0,c1,c2,c3/1.0, 256.0, 53.0, 16.0/
      print *, '<<<< Convert Sp8BL15XU img to bmp or csv ',
     +   '  Ver=2010/1/27 >>>>'
      write(6,'(a$)') 'Input file name *.img =? '
      read(5,*) fnm1
      open(1,file=fnm1,access='DIRECT',recl=1)
      print *, ' Coarse graining 2*2 into 1'
      print *, ' Now loading img file. Wait about 100 sec!'
*mercury     check of header part
*      write(*,*) '=== Header of *.img is ==='
*      read(1,rec=1) da
*      write(*,'(A/A/)') 'Header top of 256bytes ia ...',da
*      write(*,'(A)') 'header is end'
*      j=3585
*----- intensity data reading and coarse graining -----
      j=1
      do 20 iy=1,4000
        call rd1ln(j,pvdat1) 
        call rd1ln(j,pvdat2)
      do 20 ix=1,2000
        i=2*ix-1
        pv(ix,iy)=(pvdat1(i)+pvdat1(i+1)+pvdat2(i)+pvdat2(i+1))/4
   20 continue
      close(1)
*---- select job ---- 
      write(*,'(A)') ' 0: convert img to bmp (2000*4000 pixcel)'
      write(*,'(A)') ' 1: monitor data and convert to csv file'
      write(*,'(A$)') '   Select 0 or 1 =? '
      read(*,*) Ians
      if(Ians.ge.1) then
*----- monitor intensity data
*      print *, 'Input pixecl position (x,y)'
      print *, 'If x<1 or 2000<x or y<1 or 4000<y then QUIT'
   40 write(6,'(A$)')  'Value at x,y =? '
        read(5,*) ix,iy
          if(ix.le.0.or.iy.le.0) goto 60
          if(ix.gt.2000.or.iy.gt.4000) goto 60
        print *,pv(ix,iy)
      goto 40
*----- output into csv format
   60 write(*,'(A$)') 'csv file out  0:No / 1:Yes =? '
      read(*,*) jans
      if(jans.gt.0) then
   65   write(*,'(A)') ' inout output region (x1,y1)-(x2,y2)'
          write(*,'(A$)') 'x1,y1='
          read(*,*) x1,y1
          if(x1.le.0.or.y1.le.0) goto 70
            print *,' value= ',pv(x1,y1)
          write(*,'(A$)') 'x2,y2='
          read(*,*) x2,y2
          if(x2.gt.2000.or.y2.gt.4000) goto 70
            print *,' value= ',pv(x1,y1)
   70   write(*,'(A$)') 'OK ?  0:No / 1:Yes =? '
          read(*,*) JYN
          if(JYN.le.0) goto 65
        write(*,'(A$)') ' output *.csv file name =? '
        read(*,*) fnm2
        open(2,file=fnm2,status='UNKNOWN')
          write(2,'(A)') 'ް`, 1'
          write(2,'(A,A)')  'SPring8 img file',FNM1
          write(2,'(A)') ' cut from 4000*8000 data'
          write(2,'(2000(A1,I5))') (',',ix,ix=x1,x2)
        do 50 iy=y1,y2
          write(2,'(I5$)') iy
          write(2,'(2000(A1,I5))') (',',pv(ix,iy),ix=x1,x2)
   50   continue
      close(2)
      endif
      else
*===== write in bmp format
      write(*,'(A)') '===== BMP file out ====='
      open(3,file='sp8img.inf',status='OLD',err=80)
      read(3,*,err=80) c0,c1,c2,c3
      close(3)
   80 write(*,'(A$)') 'Input bmp file name ?= '
      read(*,*) fnm2
        open(2,file=fnm2,access='DIRECT',recl=1)
      write(*,'(A$)') ' BG is 0: white or 1:black, =? '
        read(*,*) jwb
      write(*,'(A$)') ' Scale is 0:Linear or 1:Log =? '
        read(*,*) lls
      write(*,'(A$)') ' Intensity I= 1 ~ 65,536 is scaled as'
      if(lls.gt.0) then
        write(*,'(F8.3,A,F7.2,A)') c2,'*log10(I/',c3,')'
      else
        write(*,'(F8.3,A,F7.2)') c0,'*I/',c1
      endif
*----- bmp header
      call header(jwb)
*----- 1 byte data write
      print *,' Now writting bmp file.  Wait about 10 sec!'
      n=1078
      do 90 iy=4000,1,-1
      do 90 ix=1,2000
        pk=pv(ix,iy)
      if(pk.le.1) then
        pk=0.0
      else if(lls.gt.0) then
*log scale     
        pk=c2*log10(pk/c3)
      else
*linear scale
        pk=c0*pk/c1
      endif
      if(pk.gt.255) pk=255
        n=n+1
        write(2,rec=n) char(int(pk))
   90 continue
      close(2)
      print *, ' Output bytes=',n
      endif
*----- QUIT ----- 
      stop
      end

      subroutine rd1ln(j,pvdat)
      integer pvdat(4000) 
      character*1 da1,da2
      integer j
      do 10 ix=1,4000
        read(1,rec=j) da1
        j=j+1
        read(1,rec=j) da2
        pv=256*ichar(da1)+ichar(da2)
*Mercury       pv=ichar(da1)+256*ichar(da2)
        j=j+1
*      if(pv.ge.32768) then
*        pv=(pv-32768)*32
*      endif
        pvdat(ix)=pv
   10 continue
      return
      end

*--------------  bmp file header  -----------
      subroutine header(jwb)
      integer id(54)
      data id/66,77,54,22,122,0,0,0,0,0,54,4,0,0,40,0,0,0,208,7,0,0,
     +  160,15,0,0,1,0,8,0,4*0,0,18,122,0,175,27,0,0,175,27,0,0,8*0/
COMMENT: file size=2000*4000+1078=54+22*256+122*256^2
COMMENT: holozpntal=2000=208+7*256
COMMENT: vertical=4000=160+15*256
COMMENT: data byte=2000*4000=18*256+122*256^2
      do 10 n=1,54
        write(2,rec=n) char(id(n))
   10 continue
      n=55
      if(jwb.gt.0) then
      do 20 nn=0,255
        write(2,rec=n) char(nn)
        write(2,rec=n+1) char(nn)
        write(2,rec=n+2) char(nn)
        write(2,rec=n+3) char(0)
  20  n=n+4
      else
      do 30 nn=255,0,-1
        write(2,rec=n) char(nn)
        write(2,rec=n+1) char(nn)
        write(2,rec=n+2) char(nn)
        write(2,rec=n+3) char(0)
  30  n=n+4
      endif
      return
      end

